package cn.com.infosec.asn1.x509;

import cn.com.infosec.asn1.DEREncodable;
import cn.com.infosec.asn1.DERObjectIdentifier;
import cn.com.infosec.asn1.DEROctetString;
import cn.com.infosec.asn1.DEROutputStream;
import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.util.Hashtable;
import java.util.Vector;

public class X509ExtensionsGenerator {
   private Hashtable extensions;
   private Vector extOrdering;

   public X509ExtensionsGenerator() {
      X509ExtensionsGenerator var10000 = this;
      X509ExtensionsGenerator var10001 = this;
      super();
      Hashtable var1;
      var1 = new Hashtable.<init>();
      var10001.extensions = var1;
      Vector var2;
      var2 = new Vector.<init>();
      var10000.extOrdering = var2;
   }

   public void reset() {
      X509ExtensionsGenerator var10000 = this;
      X509ExtensionsGenerator var10001 = this;
      Hashtable var1;
      var1 = new Hashtable.<init>();
      var10001.extensions = var1;
      Vector var2;
      var2 = new Vector.<init>();
      var10000.extOrdering = var2;
   }

   public void addExtension(DERObjectIdentifier oid, boolean critical, DEREncodable value) {
      X509ExtensionsGenerator var10000 = this;
      ByteArrayOutputStream var5;
      ByteArrayOutputStream var10001 = var5 = new ByteArrayOutputStream;
      var10001.<init>();
      DEREncodable var10003 = value;
      DEROutputStream var10002 = new DEROutputStream(var5);

      try {
         var10002.writeObject(var10003);
      } catch (IOException var4) {
         throw new IllegalArgumentException("error encoding value: " + var4);
      }

      byte[] var6 = var10001.toByteArray();
      var10000.addExtension(oid, critical, var6);
   }

   public void addExtension(DERObjectIdentifier oid, boolean critical, byte[] value) {
      if (!this.extensions.containsKey(oid)) {
         this.extOrdering.addElement(oid);
         Hashtable var10000 = this.extensions;
         DERObjectIdentifier var10001 = oid;
         X509Extension var4;
         X509Extension var10002 = var4 = new X509Extension;
         DEROctetString oid1;
         oid1 = new DEROctetString.<init>(value);
         var10002.<init>(critical, oid1);
         var10000.put(var10001, var4);
      } else {
         throw new IllegalArgumentException("extension " + oid + " already added");
      }
   }

   public boolean isEmpty() {
      return this.extOrdering.isEmpty();
   }

   public X509Extensions generate() {
      X509ExtensionsGenerator var10002 = this;
      Vector var1 = this.extOrdering;
      return new X509Extensions(var1, var10002.extensions);
   }
}
